const fs = require('fs');
const res = require('path').resolve;
const exec = require('child_process').execSync;

const ora = require('ora');

const cwd = process.cwd();

function main(argv) {
  const errors = [];

  const name = (
    String(argv.n) ||
    String(argv.name) ||
    argv._[0] ||
    'new project'
  ).toLowerCase();
  const deps = [].concat(argv.r || [], argv.require || []);

  const copyFileSpinner = ora('Copying template files').start();

  const files = fs.readdirSync('../template/');

  const dir = name;

  fs.mkdirSync(name);

  files.forEach(file => {
    copyFileSpinner.text = `Copying ${file}`;
    try {
      const data = fs
        .readFileSync(`../template/${file}`, 'utf8')
        .replace('{{ name }}', name);
      fs.writeFileSync(res(cwd, dir, file), data);
    } catch {
      errors.push(`${file} failed to copy.`);
    }
  });

  copyFileSpinner.stop();

  const depSpinner = ora('Installing Dependencies.').start();

  deps.forEach(dep => {
    depSpinner.text = `Installing ${dep}`;
    try {
      exec(`npm install ${dep}`);
    } catch {
      errors.push(`${dep} failed to install.`);
    }
  });

  depSpinner.stop();

  console.error(`Errors:
    ${errors.join('\n  ') || 'None'}`);
}

exports.main = main;
